# $Revision: 1.34 $, $Date: 2012/01/30 19:03:55 $
#
# Conditional build:
%bcond_with	luastatic        # build dietlibc-based static lua version
#
Summary:	A simple lightweight powerful embeddable programming language
Summary(pl.UTF-8):	Prosty, lekki ale potężny, osadzalny język programowania
Name:		lua50
Version:	5.0.3
Release:	4
License:	MIT
Group:		Development/Languages
Source0:	http://www.lua.org/ftp/lua-%{version}.tar.gz
# Source0-md5:	feee27132056de2949ce499b0ef4c480
%define		_refman_version	5.0
Source1:	http://www.lua.org/ftp/refman-%{_refman_version}.ps.gz
# Source1-md5:	4b0cedef4880bf925da9537520d93b57
Patch0:		lua5-link.patch
Patch1:		%{name}-Makefile.patch
URL:		http://www.lua.org/
%{?with_luastatic:BuildRequires:       dietlibc-static}
Requires:	%{name}-libs = %{version}-%{release}
Provides:	lua = %{version}
Obsoletes:	lua < 4.0.1
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Lua is a powerful, light-weight programming language designed for
extending applications. It is also frequently used as a
general-purpose, stand-alone language. It combines simple procedural
syntax (similar to Pascal) with powerful data description constructs
based on associative arrays and extensible semantics. Lua is
dynamically typed, interpreted from bytecodes, and has automatic
memory management with garbage collection, making it ideal for
configuration, scripting, and rapid prototyping.

This version has compiled in support for dynamic libraries in baselib.

%description -l pl.UTF-8
Lua to język programowania o dużych możliwościach ale lekki,
przeznaczony do rozszerzania aplikacji. Jest też często używany jako
samodzielny język ogólnego przeznaczenia. Łączy prostą proceduralną
składnię (podobną do Pascala) z potężnymi konstrukcjami opisu danych
bazującymi na tablicach asocjacyjnych i rozszerzalnej składni. Lua ma
dynamiczny system typów, interpretowany z bytecodu i automatyczne
zarządzanie pamięcią z odśmiecaczem, co czyni go idealnym do
konfiguracji, skryptów i szybkich prototypów.

Ta wersja ma wkompilowaną obsługę ładowania dynamicznych bibliotek.

%package libs
Summary:	lua 5.0.x libraries
Summary(pl.UTF-8):	Biblioteki lua 5.0.x
Group:		Libraries

%description libs
lua 5.0.x libraries.

%description libs -l pl.UTF-8
Biblioteki lua 5.0.x.

%package devel
Summary:	Header files for Lua
Summary(pl.UTF-8):	Pliki nagłówkowe dla Lua
Group:		Development/Languages
Requires:	%{name}-libs = %{version}-%{release}
Provides:	lua-devel = %{version}

%description devel
Header files needed to embed Lua in C/C++ programs and docs for the
language.

%description devel -l pl.UTF-8
Pliki nagłówkowe potrzebne do włączenia Lua do programów w C/C++ oraz
dokumentacja samego języka.

%package static
Summary:	Static Lua libraries
Summary(pl.UTF-8):	Biblioteki statyczne Lua
Group:		Development/Languages
Requires:	%{name}-devel = %{version}-%{release}
Provides:	lua-static = %{version}

%description static
Static Lua libraries.

%description static -l pl.UTF-8
Biblioteki statyczne Lua.

%package luastatic
Summary:        Static Lua interpreter
Summary(pl.UTF-8):	Statycznie skonsolidowany interpreter lua
Group:		Development/Languages

%description luastatic
Static lua interpreter.

%description luastatic -l pl.UTF-8
Statycznie skonsolidowany interpreter lua.

%prep
%setup -q -n lua-%{version}
cp -f %{SOURCE1} refman.ps.gz
%patch0 -p1
%patch1 -p1

%build
%if %{with luastatic}
%{__make} all sobin \
	CC="diet %{__cc}" \
	MYCFLAGS="%{rpmcflags} -fPIC -Os" \
	EXTRA_DEFS="-DPIC -D_GNU_SOURCE"
mv bin bin.static
%{__make} clean
%endif

%{__make} -j1 all so sobin \
	CC="%{__cc}" \
	MYCFLAGS="%{rpmcflags} -fPIC" \
	EXTRA_DEFS="-DPIC -D_GNU_SOURCE"

rm -f test/{lua,luac}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_libdir}/lua}

%{__make} soinstall install \
	INSTALL_ROOT=$RPM_BUILD_ROOT%{_prefix} \
	INSTALL_BIN=$RPM_BUILD_ROOT%{_bindir} \
	INSTALL_INC=$RPM_BUILD_ROOT%{_includedir}/lua50 \
	INSTALL_LIB=$RPM_BUILD_ROOT%{_libdir} \
	INSTALL_MAN=$RPM_BUILD_ROOT%{_mandir}/man1

# change name from lua to lua50
for i in $RPM_BUILD_ROOT%{_bindir}/* ; do mv ${i}{,50} ; done
mv $RPM_BUILD_ROOT%{_libdir}/liblua{,50}.a
mv $RPM_BUILD_ROOT%{_libdir}/liblualib{,50}.a

rm $RPM_BUILD_ROOT%{_libdir}/lib*.so
ln -s liblua.so.5.0 $RPM_BUILD_ROOT%{_libdir}/liblua50.so
ln -s liblualib.so.5.0 $RPM_BUILD_ROOT%{_libdir}/liblualib50.so

%if %{with luastatic}
install bin.static/lua $RPM_BUILD_ROOT%{_bindir}/lua50.static
install bin.static/luac $RPM_BUILD_ROOT%{_bindir}/luac50.static
%endif

# create pkgconfig file
install -d $RPM_BUILD_ROOT%{_pkgconfigdir}
cat > $RPM_BUILD_ROOT%{_pkgconfigdir}/lua50.pc <<'EOF'
prefix=%{_prefix}
exec_prefix=%{_exec_prefix}
includedir=%{_includedir}/%{name}
libdir=%{_libdir}
interpreter=%{_bindir}/%{name}
compiler=%{_bindir}/luac50

Name: Lua
Description: An extension programming language
Version: %{version}
Cflags: -I%{_includedir}/%{name}
Libs: -L%{_libdir} -llua50 -llualib50 -ldl -lm
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post   libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/lua50
%attr(755,root,root) %{_bindir}/luac50
%{_mandir}/man1/lua50.1*
%{_mandir}/man1/luac50.1*

%files libs
%defattr(644,root,root,755)
%doc COPYRIGHT HISTORY README
%attr(755,root,root) %{_libdir}/lib*.so.*.*

%files devel
%defattr(644,root,root,755)
%doc refman.ps.gz doc test
%attr(755,root,root) %{_libdir}/lib*.so
%{_includedir}/lua50
%{_pkgconfigdir}/lua50.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/lib*.a

%if %{with luastatic}
%files luastatic
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/*static
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: lua50.spec,v $
Revision 1.34  2012/01/30 19:03:55  glen
- -libs Group: Libraries

Revision 1.33  2009/03/23 14:10:51  baggins
- unify dietlibc compile options and calls

Revision 1.32  2008/07/27 22:25:01  arekm
- release 3

Revision 1.31  2007-02-13 06:46:53  glen
- tabs in preamble

Revision 1.30  2007/02/12 13:24:36  qrczak
- Completed the UTF-8 conversion.

Revision 1.29  2007/02/12 00:49:06  baggins
- converted to UTF-8

Revision 1.28  2006/07/23 09:40:17  qboosh
- updated Makefile patch to install lua,luac manuals
- renamed .pc file to lua50.pc
- release 2

Revision 1.27  2006/07/11 20:14:28  glen
- up to 5.0.3 (builds)

Revision 1.26  2006/01/05 13:25:05  qrczak
- Changed $i{,50} to ${i}{,50} - needed if sh is zsh.

Revision 1.25  2005/10/10 11:05:03  glen
- rel 6

Revision 1.24  2005/09/03 17:10:42  glen
- use lua.pc for pkgconfig file (not to patch configure.ac everywhere when program needs pkgconfig file)

Revision 1.23  2005/08/22 15:27:36  glen
- fix compiler path in pkgconfig file

Revision 1.22  2005/08/22 15:22:21  glen
- rel 5 with included pkgconfig. STBR aswell

Revision 1.21  2005/08/22 15:19:20  glen
- create lua50.pc. inspired from gentoo

Revision 1.20  2005/08/22 14:36:22  glen
- parallel make unfriendly make

Revision 1.19  2005/08/11 09:46:18  radek
- bcond_with(out) is followed by one \t, then bcond's name.

Revision 1.18  2005/05/09 01:17:12  pluto
- install fixed, log fixed, release 4 for Th.

Revision 1.17  2005/05/09 00:54:02  pluto
- cosmetics.

Revision 1.16  2004/05/28 11:28:46  areq
- typo

Revision 1.15  2004/05/28 11:25:11  areq
- add subpackage luastatic with static lua interpreter

Revision 1.14  2004/04/18 17:18:36  areq
- CC="%{__cc}"

Revision 1.13  2004/04/10 15:16:26  qboosh
- don't rename shared libs themselves - they don't conflict and renaming them
  caused problems with soname symlinks
- release 3

Revision 1.12  2004/03/28 17:31:34  wolf
- let lua40 and lua50 coexist

Revision 1.11  2004/03/18 19:02:57  wolf
- MIT license

Revision 1.10  2004/03/06 02:12:48  qboosh
- updated to 5.0.2

Revision 1.9  2003/12/03 20:27:17  qboosh
- updated to 5.0.1 (and new refman 5.0), fixed link patch once again

Revision 1.8  2003/05/28 12:59:38  malekith
- massive attack: source-md5

Revision 1.7  2003/05/25 05:50:19  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.6  2003/05/14 12:32:58  qboosh
- base R: -libs, added libs descriptions

Revision 1.5  2003/05/14 08:57:03  wiget
- added missing defattr

Revision 1.4  2003/05/14 07:47:56  wiget
- fix R: in -devel

Revision 1.3  2003/05/14 07:40:43  wiget
- added libs package

Revision 1.2  2003/05/12 16:56:58  wiget
- allow installing lua50 without uninstaling lua40

Revision 1.1  2003/04/25 18:13:35  misi3k
- updated to 5.0

Revision 1.11  2003/01/10 19:48:55  kloczek
- cosmetics.

Revision 1.10  2002/12/27 23:22:07  qboosh
- OK, my mistake... fixed, link patch is back

Revision 1.9  2002/12/27 20:58:22  depesz
- patch commented out - now it compiles
- somebody (rrw???) who knows this software should check this out

Revision 1.8  2002/12/18 20:05:40  qboosh
- added link patch (link using gcc not ld, set SONAME)
- release 5

Revision 1.7  2002/11/29 23:58:08  juandon
- added Provides: for lua-*
- Release still 4

Revision 1.6  2002/11/29 23:40:08  juandon
- added Obsoletes: for lua-*
- removed unused dirs
- Release 4

Revision 1.5  2002/11/01 13:15:47  malekith
- I guess the idea was to rename *package* not only spec file
- release 3

Revision 1.4  2002/10/19 15:28:45  wolf
- rel 2
- there is no patch0
- lib*.so.*.* go to main package, symlinks go to devel

Revision 1.3  2002/09/22 22:20:11  rrw
- removed no longer needed buildreq: unzip;
- corrected thinko made by me in previous log entry;

Revision 1.2  2002/08/31 14:41:10  rrw
- removed patches since current lua now has its own implementation of DLL and require();
- Not Finished Yet

Revision 1.1  2002/08/31 14:36:43  rrw
- there is no 'lua' package anymore; from now on lua packages will be named
  lua40, lua50 and so forth, since they are incompatible and some software
  may require one version or another;
